Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.sql
Interface Statement

All Known Subinterfaces:
  CallableStatement, PreparedStatement

public interface Statement

The object used for executing a static SQL statement and returning the results it produces.

By default, only one `ResultSet` object per `Statement` object can be open at the same time. Therefore, if the reading of one `ResultSet` object is interleaved with the reading of another, each must have been generated by different `Statement` objects. All execution methods in the `Statement` interface implicitly close a statment's current `ResultSet` object if an open one exists.

See Also:
  `Connection.createStatement()`, `ResultSet`

Field Summary
`static int` | `CLOSE_ALL_RESULTS` The constant indicating that all `ResultSet` objects that have previously been kept open should be closed when calling `getMoreResults`.
`static int` | `CLOSE_CURRENT_RESULT` The constant indicating that the current `ResultSet` object should be closed when calling `getMoreResults`.
`static int` | `EXECUTE_FAILED` The constant indicating that an error occured while executing a batch statement.
`static int` | `KEEP_CURRENT_RESULT` The constant indicating that the current `ResultSet` object should not be closed when calling `getMoreResults`.
`static int` | `NO_GENERATED_KEYS` The constant indicating that generated keys should not be made available for retrieval.
`static int` | `RETURN_GENERATED_KEYS` The constant indicating that generated keys should be made available for retrieval.
`static int` | `SUCCESS_NO_INFO` The constant indicating that a batch statement executed successfully but that no count of the number of rows it affected is available.

Method Summary
`void` | `addBatch(String sql)` Adds the given SQL command to the current list of commmands for this `Statement` object.
`void` | `cancel()` Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement.
`void` | `clearBatch()` Empties this `Statement` object's current list of SQL commands.
`void` | `clearWarnings()` Clears all the warnings reported on this `Statement` object.
`void` | `close()` Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.
`boolean` | `execute(String sql)` Executes the given SQL statement, which may return multiple results.
`boolean` | `execute(String sql, int autoGeneratedKeys)` Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval.
`boolean` | `execute(String sql, int[] columnIndexes)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`boolean` | `execute(String sql, String[] columnNames)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int[]` | `executeBatch()` Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
`ResultSet` | `executeQuery(String sql)` Executes the given SQL statement, which returns a single `ResultSet` object.
`int` | `executeUpdate(String sql)` Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.
`int` | `executeUpdate(String sql, int autoGeneratedKeys)` Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.
`int` | `executeUpdate(String sql, int[] columnIndexes)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int` | `executeUpdate(String sql, String[] columnNames)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`Connection` | `getConnection()` Retrieves the `Connection` object that produced this `Statement` object.
`int` | `getFetchDirection()` Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object.
`int` | `getFetchSize()` Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object.
`ResultSet` | `getGeneratedKeys()` Retrieves any auto-generated keys created as a result of executing this `Statement` object.
`int` | `getMaxFieldSize()` Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
`int` | `getMaxRows()` Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain.
`boolean` | `getMoreResults()` Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.
`boolean` | `getMoreResults(int current)` Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.
`int` | `getQueryTimeout()` Retrieves the number of seconds the driver will wait for a `Statement` object to execute.
`ResultSet` | `getResultSet()` Retrieves the current result as a `ResultSet` object.
`int` | `getResultSetConcurrency()` Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.
`int` | `getResultSetHoldability()` Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.
`int` | `getResultSetType()` Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.
`int` | `getUpdateCount()` Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned.
`SQLWarning` | `getWarnings()` Retrieves the first warning reported by calls on this `Statement` object.
`void` | `setCursorName(String name)` Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods.
`void` | `setEscapeProcessing(boolean enable)` Sets escape processing on or off.
`void` | `setFetchDirection(int direction)` Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object.
`void` | `setFetchSize(int rows)` Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed.
`void` | `setMaxFieldSize(int max)` Sets the limit for the maximum number of bytes in a `ResultSet` column storing character or binary values to the given number of bytes.
`void` | `setMaxRows(int max)` Sets the limit for the maximum number of rows that any `ResultSet` object can contain to the given number.
`void` | `setQueryTimeout(int seconds)` Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds.

Field Detail

### CLOSE_CURRENT_RESULT

    public static final int CLOSE_CURRENT_RESULT

  The constant indicating that the current `ResultSet` object should be closed when calling `getMoreResults`.

  Since:
    1.4
See Also:
  Constant Field Values

### KEEP_CURRENT_RESULT

    public static final int KEEP_CURRENT_RESULT

  The constant indicating that the current `ResultSet` object should not be closed when calling `getMoreResults`.

  Since:
    1.4
See Also:
  Constant Field Values

### CLOSE_ALL_RESULTS

    public static final int CLOSE_ALL_RESULTS

  The constant indicating that all `ResultSet` objects that have previously been kept open should be closed when calling `getMoreResults`.

  Since:
    1.4
See Also:
  Constant Field Values

### SUCCESS_NO_INFO

    public static final int SUCCESS_NO_INFO

  The constant indicating that a batch statement executed successfully but that no count of the number of rows it affected is available.

  Since:
    1.4
See Also:
  Constant Field Values

### EXECUTE_FAILED

    public static final int EXECUTE_FAILED

  The constant indicating that an error occured while executing a batch statement.

  Since:
    1.4
See Also:
  Constant Field Values

### RETURN_GENERATED_KEYS

    public static final int RETURN_GENERATED_KEYS

  The constant indicating that generated keys should be made available for retrieval.

  Since:
    1.4
See Also:
  Constant Field Values

### NO_GENERATED_KEYS

    public static final int NO_GENERATED_KEYS

  The constant indicating that generated keys should not be made available for retrieval.

  Since:
    1.4
See Also:
  Constant Field Values

Method Detail

### executeQuery

    public ResultSet executeQuery(String sql)
                           throws SQLException

  Executes the given SQL statement, which returns a single `ResultSet` object.

  Parameters:
    `sql` - an SQL statement to be sent to the database, typically a static SQL `SELECT` statement
  Returns:
    a `ResultSet` object that contains the data produced by the given query; never `null`
  Throws:
    `SQLException` - if a database access error occurs or the given SQL statement produces anything other than a single `ResultSet` object

### executeUpdate

    public int executeUpdate(String sql)
                      throws SQLException

  Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.

  Parameters:
    `sql` - an SQL `INSERT`, `UPDATE` or `DELETE` statement or an SQL statement that returns nothing
  Returns:
    either the row count for `INSERT`, `UPDATE` or `DELETE` statements, or `0` for SQL statements that return nothing
  Throws:
    `SQLException` - if a database access error occurs or the given SQL statement produces a `ResultSet` object

### close

    public void close()
               throws SQLException

  Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed. It is generally good practice to release resources as soon as you are finished with them to avoid tying up database resources.

  Calling the method `close` on a `Statement` object that is already closed has no effect.

  Note: A `Statement` object is automatically closed when it is garbage collected. When a `Statement` object is closed, its current `ResultSet` object, if one exists, is also closed.

  Throws:
    `SQLException` - if a database access error occurs

### getMaxFieldSize

    public int getMaxFieldSize()
                        throws SQLException

  Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, and `LONGVARCHAR` columns. If the limit is exceeded, the excess data is silently discarded.

  Returns:
    the current column size limit for columns storing character and binary values; zero means there is no limit
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setMaxFieldSize(int)`

### setMaxFieldSize

    public void setMaxFieldSize(int max)
                         throws SQLException

  Sets the limit for the maximum number of bytes in a `ResultSet` column storing character or binary values to the given number of bytes. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, and `LONGVARCHAR` fields. If the limit is exceeded, the excess data is silently discarded. For maximum portability, use values greater than 256.

  Parameters:
    `max` - the new column size limit in bytes; zero means there is no limit
  Throws:
    `SQLException` - if a database access error occurs or the condition max >= 0 is not satisfied
  See Also:
    `getMaxFieldSize()`

### getMaxRows

    public int getMaxRows()
                   throws SQLException

  Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain. If this limit is exceeded, the excess rows are silently dropped.

  Returns:
    the current maximum number of rows for a `ResultSet` object produced by this `Statement` object; zero means there is no limit
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setMaxRows(int)`

### setMaxRows

    public void setMaxRows(int max)
                    throws SQLException

  Sets the limit for the maximum number of rows that any `ResultSet` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.

  Parameters:
    `max` - the new max rows limit; zero means there is no limit
  Throws:
    `SQLException` - if a database access error occurs or the condition max >= 0 is not satisfied
  See Also:
    `getMaxRows()`

### setEscapeProcessing

    public void setEscapeProcessing(boolean enable)
                             throws SQLException

  Sets escape processing on or off. If escape scanning is on (the default), the driver will do escape substitution before sending the SQL statement to the database. Note: Since prepared statements have usually been parsed prior to making this call, disabling escape processing for `PreparedStatements` objects will have no effect.

  Parameters:
    `enable` - `true` to enable escape processing; `false` to disable it
  Throws:
    `SQLException` - if a database access error occurs

### getQueryTimeout

    public int getQueryTimeout()
                        throws SQLException

  Retrieves the number of seconds the driver will wait for a `Statement` object to execute. If the limit is exceeded, a `SQLException` is thrown.

  Returns:
    the current query timeout limit in seconds; zero means there is no limit
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setQueryTimeout(int)`

### setQueryTimeout

    public void setQueryTimeout(int seconds)
                         throws SQLException

  Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds. If the limit is exceeded, an `SQLException` is thrown.

  Parameters:
    `seconds` - the new query timeout limit in seconds; zero means there is no limit
  Throws:
    `SQLException` - if a database access error occurs or the condition seconds >= 0 is not satisfied
  See Also:
    `getQueryTimeout()`

### cancel

    public void cancel()
                throws SQLException

  Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement. This method can be used by one thread to cancel a statement that is being executed by another thread.

  Throws:
    `SQLException` - if a database access error occurs

### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

  Retrieves the first warning reported by calls on this `Statement` object. Subsequent `Statement` object warnings will be chained to this `SQLWarning` object.

  The warning chain is automatically cleared each time a statement is (re)executed. This method may not be called on a closed `Statement` object; doing so will cause an `SQLException` to be thrown.

  Note: If you are processing a `ResultSet` object, any warnings associated with reads on that `ResultSet` object will be chained on it rather than on the `Statement` object that produced it.

  Returns:
    the first `SQLWarning` object or `null` if there are no warnings
  Throws:
    `SQLException` - if a database access error occurs or this method is called on a closed statement

### clearWarnings

    public void clearWarnings()
                       throws SQLException

  Clears all the warnings reported on this `Statement` object. After a call to this method, the method `getWarnings` will return `null` until a new warning is reported for this `Statement` object.

  Throws:
    `SQLException` - if a database access error occurs

### setCursorName

    public void setCursorName(String name)
                       throws SQLException

  Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods. This name can then be used in SQL positioned update or delete statements to identify the current row in the `ResultSet` object generated by this statement. If the database does not support positioned update/delete, this method is a noop. To insure that a cursor has the proper isolation level to support updates, the cursor's `SELECT` statement should have the form `SELECT FOR UPDATE`. If `FOR UPDATE` is not present, positioned updates may fail.

  Note: By definition, the execution of positioned updates and deletes must be done by a different `Statement` object than the one that generated the `ResultSet` object being used for positioning. Also, cursor names must be unique within a connection.

  Parameters:
    `name` - the new cursor name, which must be unique within a connection
  Throws:
    `SQLException` - if a database access error occurs

### execute

    public boolean execute(String sql)
                    throws SQLException

  Executes the given SQL statement, which may return multiple results. In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

  The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

  Parameters:
    `sql` - any SQL statement
  Returns:
    `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

### getResultSet

    public ResultSet getResultSet()
                           throws SQLException

  Retrieves the current result as a `ResultSet` object. This method should be called only once per result.

  Returns:
    the current result as a `ResultSet` object or `null` if the result is an update count or there are no more results
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `execute(java.lang.String)`

### getUpdateCount

    public int getUpdateCount()
                       throws SQLException

  Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned. This method should be called only once per result.

  Returns:
    the current result as an update count; -1 if the current result is a `ResultSet` object or there are no more results
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `execute(java.lang.String)`

### getMoreResults

    public boolean getMoreResults()
                           throws SQLException

  Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.

  There are no more results when the following is true:

            (!getMoreResults() && (getUpdateCount() == -1)

  Returns:
    `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `execute(java.lang.String)`

### setFetchDirection

    public void setFetchDirection(int direction)
                           throws SQLException

  Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object. The default value is `ResultSet.FETCH_FORWARD`.

  Note that this method sets the default fetch direction for result sets generated by this `Statement` object. Each result set has its own methods for getting and setting its own fetch direction.

  Parameters:
    `direction` - the initial direction for processing rows
  Throws:
    `SQLException` - if a database access error occurs or the given direction is not one of `ResultSet.FETCH_FORWARD`, `ResultSet.FETCH_REVERSE`, or `ResultSet.FETCH_UNKNOWN`
  Since:
    1.2
See Also:
  `getFetchDirection()`

### getFetchDirection

    public int getFetchDirection()
                          throws SQLException

  Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object. If this `Statement` object has not set a fetch direction by calling the method `setFetchDirection`, the return value is implementation-specific.

  Returns:
    the default fetch direction for result sets generated from this `Statement` object
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
See Also:
  `setFetchDirection(int)`

### setFetchSize

    public void setFetchSize(int rows)
                      throws SQLException

  Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed. The number of rows specified affects only result sets created using this statement. If the value specified is zero, then the hint is ignored. The default value is zero.

  Parameters:
    `rows` - the number of rows to fetch
  Throws:
    `SQLException` - if a database access error occurs, or the condition 0 <= `rows` <= `this.getMaxRows()` is not satisfied.
  Since:
    1.2
See Also:
  `getFetchSize()`

### getFetchSize

    public int getFetchSize()
                     throws SQLException

  Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object. If this `Statement` object has not set a fetch size by calling the method `setFetchSize`, the return value is implementation-specific.

  Returns:
    the default fetch size for result sets generated from this `Statement` object
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
See Also:
  `setFetchSize(int)`

### getResultSetConcurrency

    public int getResultSetConcurrency()
                                throws SQLException

  Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.

  Returns:
    either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2

### getResultSetType

    public int getResultSetType()
                         throws SQLException

  Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.

  Returns:
    one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2

### addBatch

    public void addBatch(String sql)
                  throws SQLException

  Adds the given SQL command to the current list of commmands for this `Statement` object. The commands in this list can be executed as a batch by calling the method `executeBatch`.

  NOTE: This method is optional.

  Parameters:
    `sql` - typically this is a static SQL `INSERT` or `UPDATE` statement
  Throws:
    `SQLException` - if a database access error occurs, or the driver does not support batch updates
  Since:
    1.2
See Also:
  `executeBatch()`

### clearBatch

    public void clearBatch()
                    throws SQLException

  Empties this `Statement` object's current list of SQL commands.

  NOTE: This method is optional.

  Throws:
    `SQLException` - if a database access error occurs or the driver does not support batch updates
  Since:
    1.2
See Also:
  `addBatch(java.lang.String)`

### executeBatch

    public int[] executeBatch()
                       throws SQLException

  Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `int` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeBatch` may be one of the following:
  1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
  2. A value of `SUCCESS_NO_INFO` -- indicates that the command was processed successfully but that the number of rows affected is unknown

     If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

  3. A value of `EXECUTE_FAILED` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

  A driver is not required to implement this method. The possible implementations and return values have been modified in the Java 2 SDK, Standard Edition, version 1.3 to accommodate the option of continuing to proccess commands in a batch update after a `BatchUpdateException` obejct has been thrown.

  Returns:
    an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.
  Throws:
    `SQLException` - if a database access error occurs or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the commands sent to the database fails to execute properly or attempts to return a result set.
  Since:
    1.3

### getConnection

    public Connection getConnection()
                             throws SQLException

  Retrieves the `Connection` object that produced this `Statement` object.

  Returns:
    the connection that produced this statement
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2

### getMoreResults

    public boolean getMoreResults(int current)
                           throws SQLException

  Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.

  There are no more results when the following is true:

            (!getMoreResults() && (getUpdateCount() == -1)

  Parameters:
    `current` - one of the following `Statement` constants indicating what should happen to current `ResultSet` objects obtained using the method `getResultSetCLOSE_CURRENT_RESULT`, `KEEP_CURRENT_RESULT`, or `CLOSE_ALL_RESULTS`
  Returns:
    `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.4
See Also:
  `execute(java.lang.String)`

### getGeneratedKeys

    public ResultSet getGeneratedKeys()
                               throws SQLException

  Retrieves any auto-generated keys created as a result of executing this `Statement` object. If this `Statement` object did not generate any keys, an empty `ResultSet` object is returned.

  Returns:
    a `ResultSet` object containing the auto-generated key(s) generated by the execution of this `Statement` object
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.4

### executeUpdate

    public int executeUpdate(String sql,
                             int autoGeneratedKeys)
                      throws SQLException

  Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.

  Parameters:
    `sql` - must be an SQL `INSERT`, `UPDATE` or `DELETE` statement or an SQL statement that returns nothing
    `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: `Statement.RETURN_GENERATED_KEYS` `Statement.NO_GENERATED_KEYS`
  Returns:
    either the row count for `INSERT`, `UPDATE` or `DELETE` statements, or `0` for SQL statements that return nothing
  Throws:
    `SQLException` - if a database access error occurs, the given SQL statement returns a `ResultSet` object, or the given constant is not one of those allowed
  Since:
    1.4

### executeUpdate

    public int executeUpdate(String sql,
                             int[] columnIndexes)
                      throws SQLException

  Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. The driver will ignore the array if the SQL statement is not an `INSERT` statement.

  Parameters:
    `sql` - an SQL `INSERT`, `UPDATE` or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement
    `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row
  Returns:
    either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing
  Throws:
    `SQLException` - if a database access error occurs or the SQL statement returns a `ResultSet` object
  Since:
    1.4

### executeUpdate

    public int executeUpdate(String sql,
                             String[] columnNames)
                      throws SQLException

  Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. The driver will ignore the array if the SQL statement is not an `INSERT` statement.

  Parameters:
    `sql` - an SQL `INSERT`, `UPDATE` or `DELETE` statement or an SQL statement that returns nothing
    `columnNames` - an array of the names of the columns that should be returned from the inserted row
  Returns:
    either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.4

### execute

    public boolean execute(String sql,
                           int autoGeneratedKeys)
                    throws SQLException

  Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval. The driver will ignore this signal if the SQL statement is not an `INSERT` statement.

  In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

  The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

  Parameters:
    `sql` - any SQL statement
    `autoGeneratedKeys` - a constant indicating whether auto-generated keys should be made available for retrieval using the method `getGeneratedKeys`; one of the following constants: `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
  Returns:
    `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.4
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

### execute

    public boolean execute(String sql,
                           int[] columnIndexes)
                    throws SQLException

  Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the given SQL statement is not an `INSERT` statement.

  Under some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

  The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

  Parameters:
    `sql` - any SQL statement
    `columnIndexes` - an array of the indexes of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
  Returns:
    `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.4
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

### execute

    public boolean execute(String sql,
                           String[] columnNames)
                    throws SQLException

  Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the given SQL statement is not an `INSERT` statement.

  In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

  The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

  Parameters:
    `sql` - any SQL statement
    `columnNames` - an array of the names of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
  Returns:
    `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.4
See Also:
  `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

### getResultSetHoldability

    public int getResultSetHoldability()
                                throws SQLException

  Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.

  Returns:
    either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.4

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.